import vrml.Event;
import vrml.field.MFVec3f;
import vrml.field.SFBool;
import vrml.field.SFFloat;
import vrml.field.SFInt32;
import vrml.field.SFNode;
import vrml.field.SFVec2f;
import vrml.node.Node;
import vrml.node.Script;

public class wave extends Script {
   private SFFloat getFraction;
   private float fraction;
   private Node coord;
   private int type;
   private float amplitude;
   private float frequency;
   private float[] origin = new float[2];
   private float[] direction = new float[2];
   private boolean set_flag;
   private MFVec3f point;
   // $FF: renamed from: n int
   private int field_0;
   // $FF: renamed from: i int
   private int field_1;
   // $FF: renamed from: p float[]
   private float[] field_2;
   // $FF: renamed from: y float[]
   private float[] field_3;
   // $FF: renamed from: d float
   private float field_4;
   // $FF: renamed from: PI float
   private float field_5 = 3.14F;

   public void initialize() {
      try {
         this.getFraction = (SFFloat)((Script)this).getEventIn("fraction");
         this.coord = (Node)((SFNode)((Script)this).getField("coord")).getValue();
         this.type = ((SFInt32)((Script)this).getField("type")).getValue();
         this.amplitude = ((SFFloat)((Script)this).getField("amplitude")).getValue();
         this.frequency = ((SFFloat)((Script)this).getField("frequency")).getValue();
         this.set_flag = ((SFBool)((Script)this).getField("set_flag")).getValue();
         switch (this.type) {
            case 0:
            default:
               ((SFVec2f)((Script)this).getField("origin")).getValue(this.origin);
               break;
            case 1:
               ((SFVec2f)((Script)this).getField("direction")).getValue(this.direction);
               if (this.direction[0] == 0.0F && this.direction[1] == 0.0F) {
                  this.direction[0] = 1.0F;
                  this.direction[1] = 0.0F;
               } else {
                  this.field_4 = (float)Math.sqrt((double)(this.direction[0] * this.direction[0] + this.direction[1] * this.direction[1]));
                  float[] var10000 = this.direction;
                  var10000[0] /= this.field_4;
                  var10000 = this.direction;
                  var10000[1] /= this.field_4;
               }
         }

         this.point = (MFVec3f)this.coord.getExposedField("point");
         this.field_0 = this.point.getSize();
         this.field_2 = new float[this.field_0 * 3];
         this.point.getValue(this.field_2);
         if (this.set_flag) {
            this.field_3 = new float[this.field_0];

            for(this.field_1 = 0; this.field_1 < this.field_0; ++this.field_1) {
               this.field_3[this.field_1] = this.field_2[this.field_1 * 3 + 1];
            }

            return;
         }
      } catch (Exception var2) {
         System.out.println("initialize error");
         ((Throwable)var2).printStackTrace();
      }

   }

   public void processEvent(Event var1) {
      if (var1.getName().equals("fraction")) {
         this.point.getValue(this.field_2);
         if (this.set_flag) {
            for(this.field_1 = 0; this.field_1 < this.field_0; ++this.field_1) {
               this.field_2[this.field_1 * 3 + 1] = this.field_3[this.field_1];
            }
         }

         this.fraction = 2.0F * this.field_5 * this.getFraction.getValue();
         switch (this.type) {
            case 0:
            default:
               for(this.field_1 = 0; this.field_1 < this.field_0; ++this.field_1) {
                  this.field_4 = (float)Math.sqrt((double)((this.field_2[this.field_1 * 3] - this.origin[0]) * (this.field_2[this.field_1 * 3] - this.origin[0]) + (this.field_2[this.field_1 * 3 + 2] - this.origin[1]) * (this.field_2[this.field_1 * 3 + 2] - this.origin[1])));
                  float[] var2 = this.field_2;
                  int var3 = this.field_1 * 3 + 1;
                  var2[var3] += this.amplitude * this.easyCos(this.frequency * this.field_4 - this.fraction);
               }
               break;
            case 1:
               for(this.field_1 = 0; this.field_1 < this.field_0; ++this.field_1) {
                  this.field_4 = this.field_2[this.field_1 * 3] * this.direction[0] + this.field_2[this.field_1 * 3 + 2] * this.direction[1];
                  float[] var10000 = this.field_2;
                  int var10001 = this.field_1 * 3 + 1;
                  var10000[var10001] += this.amplitude * this.easyCos(this.frequency * this.field_4 - this.fraction);
               }
         }

         this.point.setValue(this.field_0 * 3, this.field_2);
      }

   }

   float easyCos(float var1) {
      if (var1 < 0.0F) {
         var1 = -var1;
      }

      var1 -= (float)((int)(var1 / (2.0F * this.field_5))) * 2.0F * this.field_5;
      if (this.field_5 <= var1) {
         var1 = 2.0F * this.field_5 - var1;
      }

      float var2;
      float var3;
      if (var1 < 0.2F * this.field_5) {
         var1 /= 0.2F * this.field_5;
         var2 = 1.0F;
         var3 = 0.809F;
      } else if (var1 < 0.4F * this.field_5) {
         var1 = (var1 - 0.2F * this.field_5) / (0.2F * this.field_5);
         var2 = 0.809F;
         var3 = 0.309F;
      } else if (var1 < 0.6F * this.field_5) {
         var1 = (var1 - 0.4F * this.field_5) / (0.2F * this.field_5);
         var2 = 0.309F;
         var3 = -0.309F;
      } else if (var1 < 0.8F * this.field_5) {
         var1 = (var1 - 0.6F * this.field_5) / (0.2F * this.field_5);
         var2 = -0.309F;
         var3 = -0.809F;
      } else {
         var1 = (var1 - 0.8F * this.field_5) / (0.2F * this.field_5);
         var2 = -0.809F;
         var3 = -1.0F;
      }

      return (1.0F - var1) * var2 + var1 * var3;
   }
}
